import { __makeTemplateObject } from "tslib";
import * as React from 'react';
import styled from 'styled-components';
import asRendition from '../../asRendition';
var ORDERED_LIST_SIZE = 1.5;
var ListBase = styled.ul(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tpadding: 0;\n\tmargin: 0;\n\tlist-style: none;\n\n\t& > li {\n\t\tdisplay: flex;\n\n\t\t:first-child {\n\t\t\tmargin-top: 0;\n\t\t}\n\n\t\t:last-child {\n\t\t\tmargin-bottom: 0;\n\t\t}\n\n\t\t:before {\n\t\t\ttext-align: center;\n\t\t}\n\t}\n"], ["\n\tpadding: 0;\n\tmargin: 0;\n\tlist-style: none;\n\n\t& > li {\n\t\tdisplay: flex;\n\n\t\t:first-child {\n\t\t\tmargin-top: 0;\n\t\t}\n\n\t\t:last-child {\n\t\t\tmargin-bottom: 0;\n\t\t}\n\n\t\t:before {\n\t\t\ttext-align: center;\n\t\t}\n\t}\n"])));
var OrderedList = styled(ListBase).attrs({ as: 'ol' })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tcounter-reset: ordered-list-counter;\n\n\t& > li {\n\t\tmargin: ", "px 0;\n\t\tcounter-increment: ordered-list-counter;\n\n\t\t:before {\n\t\t\tcontent: counter(ordered-list-counter);\n\t\t\tmargin-right: ", "px;\n\t\t\tbackground: ", ";\n\t\t\theight: ", "em;\n\t\t\twidth: ", "em;\n\t\t\tmin-width: ", "em;\n\t\t\tline-height: ", "em;\n\t\t\tcolor: white;\n\t\t\tborder-radius: 50%;\n\t\t}\n\t}\n"], ["\n\tcounter-reset: ordered-list-counter;\n\n\t& > li {\n\t\tmargin: ", "px 0;\n\t\tcounter-increment: ordered-list-counter;\n\n\t\t:before {\n\t\t\tcontent: counter(ordered-list-counter);\n\t\t\tmargin-right: ", "px;\n\t\t\tbackground: ", ";\n\t\t\theight: ", "em;\n\t\t\twidth: ", "em;\n\t\t\tmin-width: ", "em;\n\t\t\tline-height: ", "em;\n\t\t\tcolor: white;\n\t\t\tborder-radius: 50%;\n\t\t}\n\t}\n"])), function (props) { return props.theme.space[3]; }, function (props) { return props.theme.space[3]; }, function (props) { return props.theme.colors.info.main; }, ORDERED_LIST_SIZE, ORDERED_LIST_SIZE, ORDERED_LIST_SIZE, ORDERED_LIST_SIZE);
var UnorderedList = styled(ListBase)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\t& > li {\n\t\tmargin: ", "px 0;\n\n\t\t:before {\n\t\t\tcontent: '\\2022'; /* Unicode for a bullet character */\n\t\t\tmargin-right: ", "px;\n\t\t\ttransform: translateY(\n\t\t\t\t-1px\n\t\t\t); /* The bullet character is misplaced (by design it seems) by 1px, but it looks better if it is centered */\n\t\t\tcolor: ", ";\n\t\t}\n\t}\n"], ["\n\t& > li {\n\t\tmargin: ", "px 0;\n\n\t\t:before {\n\t\t\tcontent: '\\\\2022'; /* Unicode for a bullet character */\n\t\t\tmargin-right: ", "px;\n\t\t\ttransform: translateY(\n\t\t\t\t-1px\n\t\t\t); /* The bullet character is misplaced (by design it seems) by 1px, but it looks better if it is centered */\n\t\t\tcolor: ", ";\n\t\t}\n\t}\n"])), function (props) { return props.theme.space[1]; }, function (props) { return props.theme.space[3]; }, function (props) { return props.theme.colors.tertiary.main; });
var List = function (_a) {
    var children = _a.children, className = _a.className, ordered = _a.ordered;
    var ListType = ordered ? OrderedList : UnorderedList;
    return (React.createElement(ListType, { className: className }, React.Children.map(children, function (child) {
        return React.createElement("li", null, child);
    })));
};
export default asRendition(List);
var templateObject_1, templateObject_2, templateObject_3;
