import { __assign, __makeTemplateObject, __rest } from "tslib";
import React from 'react';
import FaClose from 'react-icons/lib/fa/close';
import styled, { withTheme } from 'styled-components';
import Button from '../../components/Button';
import { Flex } from '../../components/Flex';
import { getColor, opaque, px } from '../../utils';
var ICON_SIZE = 14;
var Wrapper = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ", ";\n\tpadding-right: ", ";\n\tbox-shadow: 0 0 10px 0\n\t\t", ";\n\tborder-radius: 10px;\n\tborder: 1px solid\n\t\t", ";\n\tbackground-color: ", ";\n\tcolor: ", ";\n"], ["\n\tposition: relative;\n\tmargin: 0;\n\tpadding: ", ";\n\tpadding-right: ", ";\n\tbox-shadow: 0 0 10px 0\n\t\t", ";\n\tborder-radius: 10px;\n\tborder: 1px solid\n\t\t",
    ";\n\tbackground-color: ",
    ";\n\tcolor: ", ";\n"])), function (props) { return px(props.theme.space[3]); }, function (props) { return px(props.theme.space[4]); }, function (props) { return opaque(props.theme.colors.quartenary.main, 0.15); }, function (props) {
    return props.solid
        ? getColor(props, 'bg', 'main')
        : props.theme.colors.quartenary.main;
}, function (props) {
    return props.solid ? getColor(props, 'bg', 'main') : 'white';
}, function (props) { return (props.solid ? 'white' : props.color || 'inherit'); });
var DismissButton = styled(Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: absolute;\n\theight: ", ";\n\twidth: ", ";\n\tfont-size: ", ";\n\ttop: ", ";\n\tright: ", ";\n"], ["\n\tposition: absolute;\n\theight: ", ";\n\twidth: ", ";\n\tfont-size: ", ";\n\ttop: ",
    ";\n\tright: ", ";\n"])), px(ICON_SIZE), px(ICON_SIZE), px(ICON_SIZE), function (props) {
    return px(props.theme.space[3] + (props.baselineHeight - ICON_SIZE) / 2);
}, function (props) { return px(props.theme.space[3]); });
export var DismissableContainer = withTheme(React.forwardRef(function (_a, ref) {
    var children = _a.children, onDismiss = _a.onDismiss, baselineHeight = _a.baselineHeight, solid = _a.solid, theme = _a.theme, restProps = __rest(_a, ["children", "onDismiss", "baselineHeight", "solid", "theme"]);
    var baseline = baselineHeight || theme.fontSizes[1] * theme.lineHeight;
    return (React.createElement(Wrapper, __assign({ solid: solid, ref: ref }, restProps),
        children,
        onDismiss && (React.createElement(DismissButton, { baselineHeight: baseline, color: solid ? 'white' : undefined, primary: !solid, plain: true, onClick: onDismiss },
            React.createElement(FaClose, null)))));
}));
var templateObject_1, templateObject_2;
