import * as React from 'react';
import { Coloring, DefaultProps, RenditionSystemProps, Sizing } from '../../common-types';
interface InternalAlertProps extends DefaultProps, Coloring, Sizing {
    plaintext?: boolean;
    bg?: string;
    prefix?: JSX.Element | string | false;
    onDismiss?: () => void;
}
export declare type AlertProps = InternalAlertProps & RenditionSystemProps;
declare const _default: React.FunctionComponent<AlertProps>;
export default _default;
