import { __assign, __makeTemplateObject, __rest } from "tslib";
import { Select as GrommetSelect, } from 'grommet';
import * as React from 'react';
import styled from 'styled-components';
import asRendition from '../../asRendition';
import { px } from '../../utils';
var StyledGrommetSelect = styled(GrommetSelect)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tfont-size: ", ";\n\tfont-weight: normal;\n\t/* The wrapping button component has borders of 1px, and changing it's height messes up the drop alignment, so we subtract the border width on the input */\n\theight: ", ";\n\tpadding: ", ";\n\tpadding-left: 20px;\n"], ["\n\tfont-family: ", ";\n\tfont-size: ", ";\n\tfont-weight: normal;\n\t/* The wrapping button component has borders of 1px, and changing it's height messes up the drop alignment, so we subtract the border width on the input */\n\theight: ",
    ";\n\tpadding: ", ";\n\tpadding-left: 20px;\n"])), function (props) { return props.theme.font; }, function (props) { return px(props.theme.fontSizes[1]); }, function (props) {
    return px((props.emphasized ? props.theme.space[5] : props.theme.space[4]) - 2);
}, function (props) { return (props.emphasized ? '14px' : '10px'); });
var Container = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t& > button {\n\t\twidth: 100%;\n\t}\n"], ["\n\t& > button {\n\t\twidth: 100%;\n\t}\n"])));
function Select(_a) {
    var size = _a.size, selected = _a.selected, focusIndicator = _a.focusIndicator, margin = _a.margin, className = _a.className, dropProps = _a.dropProps, otherProps = __rest(_a, ["size", "selected", "focusIndicator", "margin", "className", "dropProps"]);
    return (React.createElement(Container, { className: className },
        React.createElement(StyledGrommetSelect, __assign({}, otherProps, { dropProps: __assign(__assign({}, dropProps), { elevation: 'none' }), focusIndicator: false }))));
}
export default asRendition(Select);
var templateObject_1, templateObject_2;
