import { __assign, __makeTemplateObject, __rest } from "tslib";
import copyToClipboard from 'copy-to-clipboard';
import * as React from 'react';
import FaClipboard from 'react-icons/lib/fa/clipboard';
import styled from 'styled-components';
import asRendition from '../../asRendition';
import { stopEvent } from '../../utils';
import { Box } from '../Box';
import Txt from '../Txt';
var Wrapper = styled(Txt.span)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: inline-block;\n\twhite-space: ", ";\n\n\t.text-with-copy__content {\n\t\twhite-space: normal;\n\t\tword-wrap: break-word;\n\t\tmargin-right: 3px;\n\t}\n\n\t& > .text-with-copy__copy_wrapper {\n\t\tdisplay: inline-block;\n\t}\n\n\t.text-with-copy__copy {\n\t\tfont-size: 0.875em;\n\t\ttransform: translateY(-0.08em);\n\t\tcursor: pointer;\n\t\tvisibility: ", ";\n\t}\n\n\tcode {\n\t\tfont-family: ", ";\n\t\tpadding: 2px 4px;\n\t\tfont-size: 90%;\n\t\tcolor: #c7254e;\n\t\tbackground-color: #f9f2f4;\n\t\tborder-radius: 2px;\n\t\twhite-space: normal;\n\t\tword-wrap: break-word;\n\t\tfont-size: 1em;\n\t\tmargin-right: 3px;\n\t\tdisplay: inline-block;\n\t}\n\n\t&:hover .text-with-copy__copy {\n\t\tvisibility: visible;\n\t}\n"], ["\n\tdisplay: inline-block;\n\twhite-space: ", ";\n\n\t.text-with-copy__content {\n\t\twhite-space: normal;\n\t\tword-wrap: break-word;\n\t\tmargin-right: 3px;\n\t}\n\n\t& > .text-with-copy__copy_wrapper {\n\t\tdisplay: inline-block;\n\t}\n\n\t.text-with-copy__copy {\n\t\tfont-size: 0.875em;\n\t\ttransform: translateY(-0.08em);\n\t\tcursor: pointer;\n\t\tvisibility: ",
    ";\n\t}\n\n\tcode {\n\t\tfont-family: ", ";\n\t\tpadding: 2px 4px;\n\t\tfont-size: 90%;\n\t\tcolor: #c7254e;\n\t\tbackground-color: #f9f2f4;\n\t\tborder-radius: 2px;\n\t\twhite-space: normal;\n\t\tword-wrap: break-word;\n\t\tfont-size: 1em;\n\t\tmargin-right: 3px;\n\t\tdisplay: inline-block;\n\t}\n\n\t&:hover .text-with-copy__copy {\n\t\tvisibility: visible;\n\t}\n"])), function (props) { return (props.code ? 'initial' : 'nowrap'); }, function (props) {
    return props.showCopyButton === 'always' ? 'visible' : 'hidden';
}, function (props) { return props.theme.monospace; });
var Base = function (_a) {
    var copy = _a.copy, code = _a.code, text = _a.text, children = _a.children, props = __rest(_a, ["copy", "code", "text", "children"]);
    var normalizedText = (text || '').toString().trim();
    var normalizedCopy = (copy || normalizedText).toString().trim();
    var contentToRender = children || normalizedText || normalizedCopy;
    return (React.createElement(Wrapper, __assign({ copy: copy, title: copy }, props, { className: "text-with-copy" }),
        !code && (React.createElement("span", { className: "text-with-copy__content" }, contentToRender)),
        code && React.createElement("code", { title: normalizedCopy }, contentToRender),
        React.createElement("span", { onClick: function (e) { return stopEvent(e); }, className: "text-with-copy__copy_wrapper" },
            React.createElement(Box, { tooltip: { text: 'Copied!', trigger: 'click' }, onClick: function () { return copyToClipboard(normalizedCopy); }, className: "text-with-copy__copy" },
                React.createElement(FaClipboard, null)))));
};
export default asRendition(Base);
var templateObject_1;
